package ch.zhaw.gartenverwaltung.gardenplan;

import ch.zhaw.gartenverwaltung.io.GardenPlan;
import ch.zhaw.gartenverwaltung.io.HardinessZoneNotSetException;
import ch.zhaw.gartenverwaltung.io.TaskDatabase;
import ch.zhaw.gartenverwaltung.io.PlantDatabase;
import ch.zhaw.gartenverwaltung.types.*;

import java.io.IOException;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Optional;

public class Gardenplanmodel {
    private GardenPlan gardenplan;
    private TaskDatabase taskDatabase;
    private PlantDatabase plantDatabase;
//  private TaskListmodel;
    private List<Crop> cropList = Collections.emptyList();

    public Gardenplanmodel() {
        try {
            cropList = gardenplan.getCrops();
        } catch (IOException ioException){
            System.err.println("The task can not be created!");
        }

    }

    public void plantCrop(Crop crop){
        cropList.add(crop);

        try {
            gardenplan.saveCrop(crop);
            createGardeningTasks(crop);
        } catch (IOException ioException){
            System.err.println("The task can not be created!");
        }

    }

    public void removeCrop(Crop crop){
        cropList.remove(crop);
        try {
            gardenplan.removeCrop(crop);
            //TaskListModel.removeTasksForCrop(crop)
        } catch (IOException ioException){
            System.err.println("The task can not be created!");
        }

    }

    public List<Crop> getCrops(){
        if(cropList.isEmpty()){
            try {
                cropList = gardenplan.getCrops();
            } catch (IOException ioException){
                System.err.println("Crops could not be loaded");
            }

        }
        return cropList;
    }

    public Optional<Crop> getCrop(Long id){
        try {
            return gardenplan.getCropById(id);

        } catch (IOException ioException){
            System.err.println("The task can not be created!");
        }
        return null;
    }

    private void createGardeningTasks(Crop crop) throws IOException, HardinessZoneNotSetException {
        //TaskListModel.generateTasksForCrop(crop)
        long plantId = crop.getPlantId();
        Optional plant;
        Task task;

        Plant plantL = plant;


        plant = plantDatabase.getPlantById(HardinessZone.ZONE_8A, plantId);

        if(plant.isPresent()){
            List<GrowthPhase> growthPhases = plantL.lifecycleForGroup(0);
            GrowthPhase growthPhase = growthPhases.get(0);
            List<TaskTemplate> taskTemplatesForLyfecycle= growthPhase.taskTemplates();

            task = taskTemplatesForLyfecycle.get(0).generateTask(crop.getStartDate());
            taskDatabase.saveTask(task);
        } else {

        }




        //TODO need to get the plants templates, or through the Growphase
        // plant.getPlantTemplates
        // CreateTaskWithTasktemplate

    }
}
